Rupert Swarbrick | 105df01 | 2021-01-29 11:33:13 +0000 | [diff] [blame] | 1 | #!/bin/bash |
| 2 | # Copyright lowRISC contributors. |
| 3 | # Licensed under the Apache License, Version 2.0, see LICENSE for details. |
| 4 | # SPDX-License-Identifier: Apache-2.0 |
| 5 | |
| 6 | # A wrapper around lintpy.py, used for CI. |
| 7 | # |
| 8 | # Expects a single argument, which is the pull request's target branch |
| 9 | # (usually "master"). |
| 10 | |
| 11 | set -e |
| 12 | |
| 13 | if [ $# != 1 ]; then |
| 14 | echo >&2 "Usage: python-lint.sh <tgt-branch>" |
| 15 | exit 1 |
| 16 | fi |
| 17 | tgt_branch="$1" |
| 18 | |
Rupert Swarbrick | 81ada4f | 2021-02-16 15:59:39 +0000 | [diff] [blame] | 19 | merge_base="$(git merge-base origin/$tgt_branch HEAD)" || { |
Rupert Swarbrick | 105df01 | 2021-01-29 11:33:13 +0000 | [diff] [blame] | 20 | echo >&2 "Failed to find fork point for origin/$tgt_branch." |
| 21 | exit 1 |
| 22 | } |
| 23 | echo "Linting python code changed since $merge_base" |
| 24 | |
| 25 | ignored_subtrees=( |
| 26 | "*/vendor/" |
| 27 | util/lowrisc_misc-linters |
| 28 | ) |
| 29 | |
| 30 | pathspec_args=("*.py") |
| 31 | for st in "${ignored_subtrees[@]}"; do |
| 32 | # This generates an argument like :!/FOO*, that tells git to |
| 33 | # ignore every path matching the glob /FOO*. See the description |
| 34 | # of pathspecs in gitglossary(7) for more information. |
| 35 | pathspec_args+=(':!/'"$st"'*') |
| 36 | done |
| 37 | |
| 38 | lintpy_cmd="util/lintpy.py --tools flake8 -f" |
| 39 | |
| 40 | # Ask git for a list of null-separated names of changed files that |
| 41 | # don't appear in an ignored directory. Pipe those through to the |
| 42 | # licence checker using xargs. Setting pipefail ensures that we'll see |
| 43 | # an error if the git diff command fails for some reason. |
| 44 | set -o pipefail |
| 45 | git diff -z --name-only --diff-filter=ACMRTUXB "$merge_base" -- \ |
| 46 | "${pathspec_args[@]}" | \ |
| 47 | xargs -0 -r $lintpy_cmd || { |
| 48 | echo -n "##vso[task.logissue type=error]" |
| 49 | echo "Python lint failed." |
| 50 | exit 1 |
| 51 | } |